% shops3.m: Create phase, intensity, and image movies.
% t3=trfopen('WtdemoRunt31.trf');
% s3=trfload(t3); % trfload is simpler than trfsel and is used more often.
sfld = trfwild(s3, [], 'fld');
scam = trfwild(s3, [], 'fpaImage');
p = tmxparams(s3.r(1)); % This gets most of the input parameters.
set(figure,'position',[10,400,300,300],'name','Pupil Irradiance');
fi = gcf;
set(figure,'position',[320,400,300,300],'name','Pupil Phase');
fp = gcf;
set(figure,'position',[630,400,300,300],'name','Point Source Image');
fps = gcf;
nt = size(s3.r(1).v(1).d,2);
xpup = opdc(75,p.propdxy);
xpsf = opdc(64, p.wavelength/p.apdiam);
gpsf.x = xpsf;
gpsf.y = xpsf;
for ii=1:nt
   figure(fi);
   imagesc(xpup,xpup,reshape(abs(sfld.r(1).v(1).d(:,ii)).^2,75,75));
   title('Amplitude');
   axis image;
   mi = getframe(gcf);
   figure(fp);
   imagesc(xpup,xpup,reshape(angle(sfld.r(1).v(1).d(:,ii)),75,75));
   title('Phase');
   axis image;
   mp = getframe(gcf);
   figure(fps);
   gpsf.g = reshape(scam.r(1).v(1).d(:,ii),64,64);
   imagesc(gpsf.x,gpsf.y,gpsf.g);
   title('Image');
   axis image;
   hold on;
   ctrd = gcentroid(gpsf, 0.01);
   plot(ctrd(2),ctrd(1),'marker', 'o', 'markeredgecolor','red','markerfacecolor','red');
   hold off;
   mps = getframe(gcf);
   mb(ii) = mi;
   mb(ii).cdata =[mi.cdata,mp.cdata,mps.cdata];
end;
close(fi);
close(fp);
close(fps);
set(figure,'position',[10,400,900,300],'name','Point Source Through Turbulence');
set(gca,'position',[0,0,1,1]);
movie(mb);